if (!defined &_NFS_NFS_H) {
    eval 'sub _NFS_NFS_H {1;}';
    require 'sys/isa_defs.ph';
    require 'sys/vfs.ph';
    require 'sys/stream.ph';
    require 'rpc/types.ph';
    if (defined &_KERNEL) {
	require 'rpc/xdr.ph';
    }
    if (defined &_KERNEL) {
	require 'sys/fcntl.ph';
	require 'sys/kstat.ph';
    }
    require 'vm/page.ph';
    require 'rpc/rpc_sztypes.ph';
    require 'sys/sysmacros.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub NFS_PROGRAM {(100003);}';
    eval 'sub NFS_VERSMIN {(2);}';
    eval 'sub NFS_VERSMAX {(3);}';
    eval 'sub NFS_VERSION {(2);}';
    eval 'sub NFS_PORT {2049;}';
    eval 'sub NFS_MAXDATA {8192;}';
    eval 'sub NFS_MAXNAMLEN {255;}';
    eval 'sub NFS_MAXPATHLEN {1024;}';
    eval 'sub NFS_TIMEO {11;}';
    eval 'sub NFS_COTS_TIMEO {100;}';
    eval 'sub NFS_RETRIES {5;}';
    eval 'sub NFS_UID_NOBODY {-2;}';
    eval 'sub NFS_GID_NOBODY {-2;}';
    eval 'sub ECTSIZE {2048;}';
    eval 'sub IETSIZE {8192;}';
    eval 'sub SO4_BITSMAJOR {8;}';
    eval 'sub SO4_BITSMINOR {8;}';
    eval 'sub SO4_MAXMAJ {0xff;}';
    eval 'sub SO4_MAXMIN {0xff;}';
    eval 'sub nfsv2_cmpdev {
        local($x) = @_;
        eval "(((($x)>> &L_BITSMINOR) >  &SO4_MAXMAJ || (($x)& &L_MAXMIN) >  &SO4_MAXMIN) ?  &NODEV : (((($x)>> &L_BITSMINOR)<< &SO4_BITSMINOR)|(($x)& &SO4_MAXMIN)))";
    }';
    eval 'sub nfsv2_expdev {
        local($x) = @_;
        eval "((((($x)>> &SO4_BITSMINOR)& &SO4_MAXMAJ)<< &L_BITSMINOR) | (($x)& &SO4_MAXMIN))";
    }';
    eval 'sub NFS_FIFO_TYPE { &NFCHR;}';
    eval 'sub NFS_FIFO_MODE { &S_IFCHR;}';
    eval 'sub NFS_FIFO_DEV {(-1);}';
    eval 'sub NA_ISFIFO {
        local($NA) = @_;
        eval "((($NA)-> &na_type ==  &NFS_FIFO_TYPE) && (($NA)-> &na_rdev ==  &NFS_FIFO_DEV))";
    }';
    eval 'sub NA_SETFIFO {
        local($NA) = @_;
        eval "{ ($NA)-> &na_type =  &NFS_FIFO_TYPE; ($NA)-> &na_rdev =  &NFS_FIFO_DEV; ($NA)-> &na_mode = (($NA)-> &na_mode&~ &S_IFMT)| &NFS_FIFO_MODE; }";
    }';
    eval 'sub NFS_FHSIZE {32;}';
    eval 'sub NFS_FHMAXDATA {(( &NFS_FHSIZE - $sizeof{\'struct fhsize\'} + 8) / 2);}';
    eval 'sub wa_fhandle { &wa_args-> &otw_wa_fhandle;}';
    eval 'sub wa_begoff { &wa_args-> &otw_wa_begoff;}';
    eval 'sub wa_offset { &wa_args-> &otw_wa_offset;}';
    eval 'sub wa_totcount { &wa_args-> &otw_wa_totcount;}';
    eval 'sub n2v_type {
        local($x) = @_;
        eval "( &NA_ISFIFO($x) ?  &VFIFO : ( &enum  &vtype)(($x)-> &na_type))";
    }';
    eval 'sub n2v_rdev {
        local($x) = @_;
        eval "( &NA_ISFIFO($x) ? 0 : ($x)-> &na_rdev)";
    }';
    eval 'sub rr_ok { &rr_u. &rr_ok_u;}';
    eval 'sub rr_attr { &rr_u. &rr_ok_u. &rrok_attr;}';
    eval 'sub rr_count { &rr_u. &rr_ok_u. &rrok_count;}';
    eval 'sub rr_bufsize { &rr_u. &rr_ok_u. &rrok_bufsize;}';
    eval 'sub rr_data { &rr_u. &rr_ok_u. &rrok_data;}';
    eval 'sub rr_mp { &rr_u. &rr_ok_u. &rrok_mp;}';
    eval 'sub ns_attr { &ns_u. &ns_attr_u;}';
    eval 'sub rl_srok { &rl_u. &rl_srok_u;}';
    eval 'sub rl_count { &rl_u. &rl_srok_u. &srok_count;}';
    eval 'sub rl_data { &rl_u. &rl_srok_u. &srok_data;}';
    eval 'sub rd_rdok { &rd_u. &rd_rdok_u;}';
    eval 'sub rd_offset { &rd_u. &rd_rdok_u. &rdok_offset;}';
    eval 'sub rd_size { &rd_u. &rd_rdok_u. &rdok_size;}';
    eval 'sub rd_eof { &rd_u. &rd_rdok_u. &rdok_eof;}';
    eval 'sub rd_entries { &rd_u. &rd_rdok_u. &rdok_entries;}';
    eval 'sub DA_FREENAME {1;}';
    eval 'sub dr_drok { &dr_u. &dr_drok_u;}';
    eval 'sub dr_fhandle { &dr_u. &dr_drok_u. &drok_fhandle;}';
    eval 'sub dr_attr { &dr_u. &dr_drok_u. &drok_attr;}';
    eval 'sub SLA_FREETNM {1;}';
    eval 'sub fs_fsok { &fs_u. &fs_fsok_u;}';
    eval 'sub fs_tsize { &fs_u. &fs_fsok_u. &fsok_tsize;}';
    eval 'sub fs_bsize { &fs_u. &fs_fsok_u. &fsok_bsize;}';
    eval 'sub fs_blocks { &fs_u. &fs_fsok_u. &fsok_blocks;}';
    eval 'sub fs_bfree { &fs_u. &fs_fsok_u. &fsok_bfree;}';
    eval 'sub fs_bavail { &fs_u. &fs_fsok_u. &fsok_bavail;}';
    if (defined &_KERNEL) {
	if (defined &_LITTLE_ENDIAN) {
	}
	if (defined &_LITTLE_ENDIAN) {
	}
	if (defined &_LITTLE_ENDIAN) {
	}
	if (defined &_LITTLE_ENDIAN) {
	}
	if (defined &_LITTLE_ENDIAN) {
	}
	if (defined &_LITTLE_ENDIAN) {
	}
    }
    eval 'sub RFS_NULL {0;}';
    eval 'sub RFS_GETATTR {1;}';
    eval 'sub RFS_SETATTR {2;}';
    eval 'sub RFS_ROOT {3;}';
    eval 'sub RFS_LOOKUP {4;}';
    eval 'sub RFS_READLINK {5;}';
    eval 'sub RFS_READ {6;}';
    eval 'sub RFS_WRITECACHE {7;}';
    eval 'sub RFS_WRITE {8;}';
    eval 'sub RFS_CREATE {9;}';
    eval 'sub RFS_REMOVE {10;}';
    eval 'sub RFS_RENAME {11;}';
    eval 'sub RFS_LINK {12;}';
    eval 'sub RFS_SYMLINK {13;}';
    eval 'sub RFS_MKDIR {14;}';
    eval 'sub RFS_RMDIR {15;}';
    eval 'sub RFS_READDIR {16;}';
    eval 'sub RFS_STATFS {17;}';
    eval 'sub RFS_NPROC {18;}';
    if (defined &_KERNEL) {
    }
    if (defined &_KERNEL) {
    }
    eval 'sub NFS3_FHSIZE {64;}';
    eval 'sub NFS3_COOKIEVERFSIZE {8;}';
    eval 'sub NFS3_CREATEVERFSIZE {8;}';
    eval 'sub NFS3_WRITEVERFSIZE {8;}';
    eval 'sub nfs3nametoolong {(-1);}';
    eval 'sub fh3_fsid { &fh3_u. &nfs_fh3_i. &fh3_i. &fh_fsid;}';
    eval 'sub fh3_len { &fh3_u. &nfs_fh3_i. &fh3_i. &fh_len;}';
    eval 'sub fh3_data { &fh3_u. &nfs_fh3_i. &fh3_i. &fh_data;}';
    eval 'sub fh3_xlen { &fh3_u. &nfs_fh3_i. &fh3_i. &fh_xlen;}';
    eval 'sub fh3_xdata { &fh3_u. &nfs_fh3_i. &fh3_i. &fh_xdata;}';
    eval 'sub resok { &res_u. &ok;}';
    eval 'sub resfail { &res_u. &fail;}';
    eval 'sub ACCESS3_READ {0x1;}';
    eval 'sub ACCESS3_LOOKUP {0x2;}';
    eval 'sub ACCESS3_MODIFY {0x4;}';
    eval 'sub ACCESS3_EXTEND {0x8;}';
    eval 'sub ACCESS3_DELETE {0x10;}';
    eval 'sub ACCESS3_EXECUTE {0x20;}';
    eval 'sub FSF3_LINK {0x1;}';
    eval 'sub FSF3_SYMLINK {0x2;}';
    eval 'sub FSF3_HOMOGENEOUS {0x8;}';
    eval 'sub FSF3_CANSETTIME {0x10;}';
    eval 'sub NFS3_PROGRAM {(100003);}';
    eval 'sub NFS_V3 {(3);}';
    eval 'sub NFSPROC3_NULL {(0);}';
    eval 'sub NFSPROC3_GETATTR {(1);}';
    eval 'sub NFSPROC3_SETATTR {(2);}';
    eval 'sub NFSPROC3_LOOKUP {(3);}';
    eval 'sub NFSPROC3_ACCESS {(4);}';
    eval 'sub NFSPROC3_READLINK {(5);}';
    eval 'sub NFSPROC3_READ {(6);}';
    eval 'sub NFSPROC3_WRITE {(7);}';
    eval 'sub NFSPROC3_CREATE {(8);}';
    eval 'sub NFSPROC3_MKDIR {(9);}';
    eval 'sub NFSPROC3_SYMLINK {(10);}';
    eval 'sub NFSPROC3_MKNOD {(11);}';
    eval 'sub NFSPROC3_REMOVE {(12);}';
    eval 'sub NFSPROC3_RMDIR {(13);}';
    eval 'sub NFSPROC3_RENAME {(14);}';
    eval 'sub NFSPROC3_LINK {(15);}';
    eval 'sub NFSPROC3_READDIR {(16);}';
    eval 'sub NFSPROC3_READDIRPLUS {(17);}';
    eval 'sub NFSPROC3_FSSTAT {(18);}';
    eval 'sub NFSPROC3_FSINFO {(19);}';
    eval 'sub NFSPROC3_PATHCONF {(20);}';
    eval 'sub NFSPROC3_COMMIT {(21);}';
    if (defined &_KERNEL) {
    }
    if (defined &_KERNEL) {
    }
    if (defined &_KERNEL) {
	if (defined &DEBUG) {
	}
    }
    if (defined &__cplusplus) {
    }
}
1;
