if (!defined &_SYS_KSTAT_H) {
    eval 'sub _SYS_KSTAT_H {1;}';
    require 'sys/types.ph';
    require 'sys/time.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub KSTAT_IOC_BASE {(ord(\'K\') << 8);}';
    eval 'sub KSTAT_IOC_CHAIN_ID { &KSTAT_IOC_BASE | 0x01;}';
    eval 'sub KSTAT_IOC_READ { &KSTAT_IOC_BASE | 0x02;}';
    eval 'sub KSTAT_IOC_WRITE { &KSTAT_IOC_BASE | 0x03;}';
    eval 'sub KSTAT_STRLEN {31;}';
    if (defined( &_KERNEL)) {
	eval 'sub KSTAT_ENTER {
	    local($k) = @_;
	    eval "{  &kmutex_t * &lp = ($k)-> &ks_lock;  &if ( &lp)  &mutex_enter( &lp); }";
	}';
	eval 'sub KSTAT_EXIT {
	    local($k) = @_;
	    eval "{  &kmutex_t * &lp = ($k)-> &ks_lock;  &if ( &lp)  &mutex_exit( &lp); }";
	}';
	eval 'sub KSTAT_UPDATE {
	    local($k, $rw) = @_;
	    eval "(*($k)-> &ks_update)(($k), ($rw))";
	}';
	eval 'sub KSTAT_SNAPSHOT {
	    local($k, $buf, $rw) = @_;
	    eval "(*($k)-> &ks_snapshot)(($k), ($buf), ($rw))";
	}';
    }
    eval 'sub KSTAT_TYPE_RAW {0;}';
    eval 'sub KSTAT_TYPE_NAMED {1;}';
    eval 'sub KSTAT_TYPE_INTR {2;}';
    eval 'sub KSTAT_TYPE_IO {3;}';
    eval 'sub KSTAT_TYPE_TIMER {4;}';
    eval 'sub KSTAT_NUM_TYPES {5;}';
    eval 'sub KSTAT_FLAG_VIRTUAL {0x01;}';
    eval 'sub KSTAT_FLAG_VAR_SIZE {0x02;}';
    eval 'sub KSTAT_FLAG_WRITABLE {0x04;}';
    eval 'sub KSTAT_FLAG_PERSISTENT {0x08;}';
    eval 'sub KSTAT_FLAG_DORMANT {0x10;}';
    eval 'sub KSTAT_FLAG_INVALID {0x20;}';
    eval 'sub KSTAT_READ {0;}';
    eval 'sub KSTAT_WRITE {1;}';
    eval 'sub KSTAT_DATA_CHAR {0;}';
    eval 'sub KSTAT_DATA_LONG {1;}';
    eval 'sub KSTAT_DATA_ULONG {2;}';
    eval 'sub KSTAT_DATA_LONGLONG {3;}';
    eval 'sub KSTAT_DATA_ULONGLONG {4;}';
    eval 'sub KSTAT_DATA_FLOAT {5;}';
    eval 'sub KSTAT_DATA_DOUBLE {6;}';
    eval 'sub KSTAT_NAMED_PTR {
        local($kptr) = @_;
        eval "(( &kstat_named_t *)($kptr)-> &ks_data)";
    }';
    eval 'sub KSTAT_INTR_HARD {0;}';
    eval 'sub KSTAT_INTR_SOFT {1;}';
    eval 'sub KSTAT_INTR_WATCHDOG {2;}';
    eval 'sub KSTAT_INTR_SPURIOUS {3;}';
    eval 'sub KSTAT_INTR_MULTSVC {4;}';
    eval 'sub KSTAT_NUM_INTRS {5;}';
    eval 'sub KSTAT_INTR_PTR {
        local($kptr) = @_;
        eval "(( &kstat_intr_t *)($kptr)-> &ks_data)";
    }';
    eval 'sub KSTAT_IO_PTR {
        local($kptr) = @_;
        eval "(( &kstat_io_t *)($kptr)-> &ks_data)";
    }';
    eval 'sub KSTAT_TIMER_PTR {
        local($kptr) = @_;
        eval "(( &kstat_timer_t *)($kptr)-> &ks_data)";
    }';
    if (defined( &_KERNEL)) {
	require 'sys/t_lock.ph';
    }
    if (defined &__cplusplus) {
    }
}
1;
