if (!defined &_SYS_VNODE_H) {
    eval 'sub _SYS_VNODE_H {1;}';
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/time.ph';
    require 'sys/cred.ph';
    require 'sys/uio.ph';
    require 'vm/seg_enum.ph';
    if (defined &_KERNEL) {
	require 'sys/buf.ph';
    }
    if (defined &__cplusplus) {
    }
    eval 'sub VROOT {0x01;}';
    eval 'sub VNOCACHE {0x02;}';
    eval 'sub VNOMAP {0x04;}';
    eval 'sub VDUP {0x08;}';
    eval 'sub VNOSWAP {0x10;}';
    eval 'sub VNOMOUNT {0x20;}';
    eval 'sub VISSWAP {0x40;}';
    eval 'sub VSWAPLIKE {0x80;}';
    eval 'sub IS_SWAPVP {
        local($vp) = @_;
        eval "((($vp)-> &v_flag & ( &VISSWAP |  &VSWAPLIKE)) != 0)";
    }';
    eval 'sub VVFSLOCK {0x100;}';
    eval 'sub VVFSWAIT {0x200;}';
    eval 'sub VVMLOCK {0x400;}';
    eval 'sub AT_TYPE {0x0001;}';
    eval 'sub AT_MODE {0x0002;}';
    eval 'sub AT_UID {0x0004;}';
    eval 'sub AT_GID {0x0008;}';
    eval 'sub AT_FSID {0x0010;}';
    eval 'sub AT_NODEID {0x0020;}';
    eval 'sub AT_NLINK {0x0040;}';
    eval 'sub AT_SIZE {0x0080;}';
    eval 'sub AT_ATIME {0x0100;}';
    eval 'sub AT_MTIME {0x0200;}';
    eval 'sub AT_CTIME {0x0400;}';
    eval 'sub AT_RDEV {0x0800;}';
    eval 'sub AT_BLKSIZE {0x1000;}';
    eval 'sub AT_NBLOCKS {0x2000;}';
    eval 'sub AT_VCODE {0x4000;}';
    eval 'sub AT_ALL {( &AT_TYPE| &AT_MODE| &AT_UID| &AT_GID| &AT_FSID| &AT_NODEID|  &AT_NLINK| &AT_SIZE| &AT_ATIME| &AT_MTIME| &AT_CTIME|  &AT_RDEV| &AT_BLKSIZE| &AT_NBLOCKS| &AT_VCODE);}';
    eval 'sub AT_STAT {( &AT_MODE| &AT_UID| &AT_GID| &AT_FSID| &AT_NODEID| &AT_NLINK|  &AT_SIZE| &AT_ATIME| &AT_MTIME| &AT_CTIME| &AT_RDEV);}';
    eval 'sub AT_TIMES {( &AT_ATIME| &AT_MTIME| &AT_CTIME);}';
    eval 'sub AT_NOSET {( &AT_NLINK| &AT_RDEV| &AT_FSID| &AT_NODEID| &AT_TYPE|  &AT_BLKSIZE| &AT_NBLOCKS| &AT_VCODE);}';
    eval 'sub VSUID {04000;}';
    eval 'sub VSGID {02000;}';
    eval 'sub VSVTX {01000;}';
    eval 'sub VREAD {00400;}';
    eval 'sub VWRITE {00200;}';
    eval 'sub VEXEC {00100;}';
    eval 'sub MODEMASK {07777;}';
    eval 'sub PERMMASK {00777;}';
    eval 'sub MANDMODE {
        local($mode) = @_;
        eval "((($mode) & ( &VSGID|( &VEXEC>>3))) ==  &VSGID)";
    }';
    eval 'sub MANDLOCK {
        local($vp, $mode) = @_;
        eval "(($vp)-> &v_type ==  &VREG &&  &MANDMODE($mode))";
    }';
    eval 'sub VSA_ACL {0x0001;}';
    eval 'sub VSA_ACLCNT {0x0002;}';
    eval 'sub VSA_DFACL {0x0004;}';
    eval 'sub VSA_DFACLCNT {0x0008;}';
    eval 'sub VOP_OPEN {
        local($vpp, $mode, $cr) = @_;
        eval "(*(*($vpp))-> &v_op-> &vop_open)($vpp, $mode, $cr)";
    }';
    eval 'sub VOP_CLOSE {
        local($vp, $f, $c, $o, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_close)($vp, $f, $c, $o, $cr)";
    }';
    eval 'sub VOP_READ {
        local($vp, $uiop, $iof, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_read)($vp, $uiop, $iof, $cr)";
    }';
    eval 'sub VOP_WRITE {
        local($vp, $uiop, $iof, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_write)($vp, $uiop, $iof, $cr)";
    }';
    eval 'sub VOP_IOCTL {
        local($vp, $cmd, $a, $f, $cr, $rvp) = @_;
        eval "(*($vp)-> &v_op-> &vop_ioctl)($vp, $cmd, $a, $f, $cr, $rvp)";
    }';
    eval 'sub VOP_SETFL {
        local($vp, $f, $a, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_setfl)($vp, $f, $a, $cr)";
    }';
    eval 'sub VOP_GETATTR {
        local($vp, $vap, $f, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_getattr)($vp, $vap, $f, $cr)";
    }';
    eval 'sub VOP_SETATTR {
        local($vp, $vap, $f, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_setattr)($vp, $vap, $f, $cr)";
    }';
    eval 'sub VOP_ACCESS {
        local($vp, $mode, $f, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_access)($vp, $mode, $f, $cr)";
    }';
    eval 'sub VOP_LOOKUP {
        local($vp, $cp, $vpp, $pnp, $f, $rdir, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_lookup)($vp, $cp, $vpp, $pnp, $f, $rdir, $cr)";
    }';
    eval 'sub VOP_CREATE {
        local($dvp, $p, $vap, $ex, $mode, $vpp, $cr) = @_;
        eval "(*($dvp)-> &v_op-> &vop_create)($dvp, $p, $vap, $ex, $mode, $vpp, $cr)";
    }';
    eval 'sub VOP_REMOVE {
        local($dvp, $p, $cr) = @_;
        eval "(*($dvp)-> &v_op-> &vop_remove)($dvp, $p, $cr)";
    }';
    eval 'sub VOP_LINK {
        local($tdvp, $fvp, $p, $cr) = @_;
        eval "(*($tdvp)-> &v_op-> &vop_link)($tdvp, $fvp, $p, $cr)";
    }';
    eval 'sub VOP_RENAME {
        local($fvp, $fnm, $tdvp, $tnm, $cr) = @_;
        eval "(*($fvp)-> &v_op-> &vop_rename)($fvp, $fnm, $tdvp, $tnm, $cr)";
    }';
    eval 'sub VOP_MKDIR {
        local($dp, $p, $vap, $vpp, $cr) = @_;
        eval "(*($dp)-> &v_op-> &vop_mkdir)($dp, $p, $vap, $vpp, $cr)";
    }';
    eval 'sub VOP_RMDIR {
        local($dp, $p, $cdir, $cr) = @_;
        eval "(*($dp)-> &v_op-> &vop_rmdir)($dp, $p, $cdir, $cr)";
    }';
    eval 'sub VOP_READDIR {
        local($vp, $uiop, $cr, $eofp) = @_;
        eval "(*($vp)-> &v_op-> &vop_readdir)($vp, $uiop, $cr, $eofp)";
    }';
    eval 'sub VOP_SYMLINK {
        local($dvp, $lnm, $vap, $tnm, $cr) = @_;
        eval "(*($dvp)-> &v_op-> &vop_symlink) ($dvp, $lnm, $vap, $tnm, $cr)";
    }';
    eval 'sub VOP_READLINK {
        local($vp, $uiop, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_readlink)($vp, $uiop, $cr)";
    }';
    eval 'sub VOP_FSYNC {
        local($vp, $syncflag, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_fsync)($vp, $syncflag, $cr)";
    }';
    eval 'sub VOP_INACTIVE {
        local($vp, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_inactive)($vp, $cr)";
    }';
    eval 'sub VOP_FID {
        local($vp, $fidp) = @_;
        eval "(*($vp)-> &v_op-> &vop_fid)($vp, $fidp)";
    }';
    eval 'sub VOP_RWLOCK {
        local($vp, $w) = @_;
        eval "(*($vp)-> &v_op-> &vop_rwlock)($vp, $w)";
    }';
    eval 'sub VOP_RWUNLOCK {
        local($vp, $w) = @_;
        eval "(*($vp)-> &v_op-> &vop_rwunlock)($vp, $w)";
    }';
    eval 'sub VOP_SEEK {
        local($vp, $ooff, $noffp) = @_;
        eval "(*($vp)-> &v_op-> &vop_seek)($vp, $ooff, $noffp)";
    }';
    eval 'sub VOP_CMP {
        local($vp1, $vp2) = @_;
        eval "(*($vp1)-> &v_op-> &vop_cmp)($vp1, $vp2)";
    }';
    eval 'sub VOP_FRLOCK {
        local($vp, $cmd, $a, $f, $o, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_frlock)($vp, $cmd, $a, $f, $o, $cr)";
    }';
    eval 'sub VOP_SPACE {
        local($vp, $cmd, $a, $f, $o, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_space)($vp, $cmd, $a, $f, $o, $cr)";
    }';
    eval 'sub VOP_REALVP {
        local($vp1, $vp2) = @_;
        eval "(*($vp1)-> &v_op-> &vop_realvp)($vp1, $vp2)";
    }';
    eval 'sub VOP_GETPAGE {
        local($vp, $of, $sz, $pr, $pl, $ps, $sg, $a, $rw, $cr) = @_;
        eval "((*($vp)-> &v_op-> &vop_getpage) ($vp, $of, $sz, $pr, $pl, $ps, $sg, $a, $rw, $cr))";
    }';
    eval 'sub VOP_PUTPAGE {
        local($vp, $of, $sz, $fl, $cr) = @_;
        eval "((*($vp)-> &v_op-> &vop_putpage)($vp, $of, $sz, $fl, $cr))";
    }';
    eval 'sub VOP_MAP {
        local($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_map) ($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr)";
    }';
    eval 'sub VOP_ADDMAP {
        local($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_addmap) ($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr)";
    }';
    eval 'sub VOP_DELMAP {
        local($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_delmap) ($vp, $of, $as, $a, $sz, $p, $mp, $fl, $cr)";
    }';
    eval 'sub VOP_POLL {
        local($vp, $events, $anyyet, $reventsp, $phpp) = @_;
        eval "(*($vp)-> &v_op-> &vop_poll)($vp, $events, $anyyet, $reventsp, $phpp)";
    }';
    eval 'sub VOP_DUMP {
        local($vp, $addr, $bn, $count) = @_;
        eval "(*($vp)-> &v_op-> &vop_dump)($vp, $addr, $bn, $count)";
    }';
    eval 'sub VOP_PATHCONF {
        local($vp, $cmd, $valp, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_pathconf)($vp, $cmd, $valp, $cr)";
    }';
    eval 'sub VOP_PAGEIO {
        local($vp, $pp, $io_off, $io_len, $flags, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_pageio)($vp, $pp, $io_off, $io_len, $flags, $cr)";
    }';
    eval 'sub VOP_DUMPCTL {
        local($vp, $flag) = @_;
        eval "(*($vp)-> &v_op-> &vop_dumpctl)($vp, $flag)";
    }';
    eval 'sub VOP_DISPOSE {
        local($vp, $pp, $fl, $dn, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_dispose)($vp, $pp, $fl, $dn, $cr)";
    }';
    eval 'sub VOP_GETSECATTR {
        local($vp, $vsap, $f, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_getsecattr) ($vp, $vsap, $f, $cr)";
    }';
    eval 'sub VOP_SETSECATTR {
        local($vp, $vsap, $f, $cr) = @_;
        eval "(*($vp)-> &v_op-> &vop_setsecattr) ($vp, $vsap, $f, $cr)";
    }';
    eval 'sub LOOKUP_DIR {0x01;}';
    if (defined &_KERNEL) {
    }
    eval 'sub VN_HOLD {
        local($vp) = @_;
        eval "{  &mutex_enter(&($vp)-> &v_lock); ($vp)-> &v_count++;  &mutex_exit(&($vp)-> &v_lock); }";
    }';
    eval 'sub VN_RELE {
        local($vp) = @_;
        eval "{  &vn_rele($vp); }";
    }';
    eval 'sub VN_INIT {
        local($vp, $vfsp, $type, $dev) = @_;
        eval "{  &mutex_init(&($vp)-> &v_lock, \\"vnode lock\\",  &MUTEX_DEFAULT,  &DEFAULT_WT); ($vp)-> &v_flag = 0; ($vp)-> &v_count = 1; ($vp)-> &v_vfsp = ($vfsp); ($vp)-> &v_type = ($type); ($vp)-> &v_rdev = ($dev); ($vp)-> &v_pages =  &NULL; ($vp)-> &v_stream =  &NULL; }";
    }';
    eval 'sub VN_CMP {
        local($VP1, $VP2) = @_;
        eval "(($VP1) == ($VP2) ? 1 : (($VP1) && ($VP2) && (($VP1)-> &v_op == ($VP2)-> &v_op) ?  &VOP_CMP($VP1, $VP2) : 0))";
    }';
    eval 'sub ATTR_UTIME {0x01;}';
    eval 'sub ATTR_EXEC {0x02;}';
    eval 'sub ATTR_COMM {0x04;}';
    eval 'sub ATTR_HINT {0x08;}';
    eval 'sub VBSIZE {
        local($vp) = @_;
        eval "(($vp)-> &v_vfsp-> &vfs_bsize)";
    }';
    eval 'sub NULLVP {(0);}';
    eval 'sub NULLVPP {(0);}';
    if (defined &_KERNEL) {
    }
    eval 'sub VN_DISPOSE {
        local($pp, $fl, $dn, $cr) = @_;
        eval "{  &extern struct vnode  &kvp;  &if (($pp)-> &p_vnode !=  &NULL && ($pp)-> &p_vnode != & &kvp)  &VOP_DISPOSE(($pp)-> &p_vnode, ($pp), ($fl), ($dn), ($cr));  &else  &if (($fl) ==  &B_FREE)  &page_free(($pp), ($dn));  &else  &page_destroy(($pp), ($dn)); }";
    }';
    if (defined &__cplusplus) {
    }
}
1;
